c last modified by Vera January 2009
c
c  precalculated lepton tensors forr VVV --> 6 leptons

      integer it, ie, iu

c  lepton spinors, polarization vectors, momenta
      double complex wep, wve, wmu, wvm, ztp, ztm
      double complex zep, zem, zmm, zmp, ae, ze, amu, zmu
      double complex wp, wm, wpp, wmp, xp, xm, ztau, atau, wbos
      double complex wa, wz, zp, wap
      double complex ztaup, ataup, xz, xa, xaz
      double complex atau1, atau2, atau3, w0, atau1p, atau2p, w0p
      double precision qp, qm, qz, qww, qwwz, qze, qzmu, qztau, qwbos
      double precision qzzw, qzzz, qzz, qzza, qa, qwz, qwza
      double precision qw0, qa1, qa2, qa3, qaa, qaaw, qzaa
      double complex aww, zww, awwz, zwwz, wpwz, wmwz, aza, zaz
      double complex wpwa, wmwa, awwa, zwwa
      double complex wpwa1, wmwa1, wpwa2, wmwa2, wpwaa, wmwaa
      double complex azza,zzza,azz,zzz,aaze,zzae,aazm,zzam
      double complex aaze1,aaze2,zzae1,zzae2
      double complex azzz, zzzz, azezm, azezt, azmzt, azaa,  zzaa
      double complex zzzz_higgs1, zzzz_higgs2, zzzz_higgs3
      double complex zzezm, zzezt, zzmzt
      double complex wpzzw, wmzzw, wzzw, wpzw1, wpzw2, wmzw1, wmzw2
      double complex wzw1, wzw2
      double complex zmup, aep, amup, zepp, wbosp, xze, xae, xzmu
      double complex xaon, xw, xamu,xatau1,xatau2

      common /wwzspinor/ wep(6,3), wve(6,3), wmu(6,3), wvm(6,3),
     1                   ztp(6,3), ztm(6,3), wp(6,3), wm(6,3),
     2                   ztau(6,3), atau(6,3),wpp(6,3), wmp(6,3), 
     3                   wap(6,3), xp, xm,ataup(6,3), ztaup(6,3), 
     4                   xz, xa, xaz, qp(0:4,3), qm(0:4,3),
     5                   qz(0:4,3), qww(0:4,3), qwwz(0:4,3)

      common /zzzspinor/ zep(6,3), zem(6,3), zmm(6,3), zmp(6,3),
     1                   ae(6,3), ze(6,3), amu(6,3), zmu(6,3),
     2                   qze(0:4,3), qzmu(0:4,3), qztau(0:4,3), 
     3                   qzzz(0:4,3)

      common /aawspinor/ atau1(6,3), atau2(6,3), w0(6,3), atau1p(6,3), 
     1	                 atau2p(6,3), w0p(6,3), xatau1, xatau2, atau3(6,3), 
     2                   qzaa(0:4,3), qa3(0:4,3), qw0(0:4,3), qa1(0:4,3), 
     3                   qa2(0:4,3), qaa(0:4,3), qaaw(0:4,3)

      common /zzwspinor/ wbos(6,3), zepp(6,3), zmup(6,3), aep(6,3), 
     1                   amup(6,3), wbosp(6,3), xze, xae, 
     2                   xzmu, xamu, xw, xaon, qzza(0:4,3),
     3                   qwbos(0:4,3), qzzw(0:4,3), qzz(0:4,3)

      common /wzaspinor/ wa(6,3), wz(6,3), zp(6,3), 
     1                   qa(0:4,3), qwz(0:4,3), qwza(0:4,3)

      common /tensww/ aww(0:5,3), zww(0:5,3),
     1                awwz(0:5,3), zwwz(0:5,3),
     2                wpwz(0:5,3), wmwz(0:5,3)

      common /tenszzz/ azzz(0:5,3), zzzz(0:5,3),
     1                 azezm(0:5,3), azezt(0:5,3), azmzt(0:5,3),
     2                 zzezm(0:5,3), zzezt(0:5,3), zzmzt(0:5,3),
     3                 zzzz_higgs1(0:5,3), zzzz_higgs2(0:5,3),
     4                 zzzz_higgs3(0:5,3) 

      common /tenszzw/ wzzw(0:5,3), wzw1(0:5,3), wzw2(0:5,3)

      common /tensaaw/ wpwa1(0:5,3), wpwa2(0:5,3), wmwa1(0:5,3),
     1	               wmwa2(0:5,3), wpwaa(0:5,3), wmwaa(0:5,3)

      common /tensvva/ awwa(0:5,3), zwwa(0:5,3),
     1                 wpwa(0:5,3), wmwa(0:5,3),
     2		       azza(0:5,3), zzza(0:5,3),
     3                 azz(0:5,3), zzz(0:5,3),
     4                 aaze(0:5,3), zzae(0:5,3),
     5                 aaze1(0:5,3), zzae1(0:5,3),
     6                 aaze2(0:5,3), zzae2(0:5,3),
     7                 aazm(0:5,3), zzam(0:5,3),
     8                 aza(0:5,3), zaz(0:5,3),
     9                 azaa(0:5,3), zzaa(0:5,3)

c-------------------------www-momenta and wavefunctions--------------------
c  lepton spinors and W+,W-, Z/A polarization vectors

      double complex wep1, wve1, wmu1, wvm1, wtp, wvt
      double complex wp1, wp2, w1m
      double complex wpp1, wpp2, w1mp, w2mp,
     1               xp1, xp2, x1m, x2m
      double precision qp1, qp2, q1m, qwp1wm, qwp2wm,
     1                 qwpwmwp, qwwwp

      double complex wep2, wve2, wmu2, wvm2, wtm,wvtbar
      double complex w1p, wm1, wm2
      double complex wmm1, wmm2, w1pm, w2pm,
     1               xm1, xmm2, x1p, x2p
      double precision q1p, qm1, qm2, qwpwm1, qwpwm2,
     1                 qwpwmwm, qwwwm

      common /wwwpspinor/ wep1(6,3), wve1(6,3), wmu1(6,3), wvm1(6,3),
     1                    wtp(6,3), wvt(6,3), wp1(6,3), wp2(6,3),
     2                    w1m(6,3), wpp1(6,3), wpp2(6,3), w1mp(6,3),
     3                    w2mp(6,3), xp1, xp2, x1m, x2m, qp1(0:4,3), 
     4                    qp2(0:4,3), q1m(0:4,3), qwp1wm(0:4,3), 
     5                    qwp2wm(0:4,3), qwpwmwp(0:4,3), qwwwp(0:4,3)

      common /wwwmspinor/ wep2(6,3), wve2(6,3), wmu2(6,3), wvm2(6,3),
     1                    wtm(6,3), wvtbar(6,3), wm1(6,3), wm2(6,3),
     2                    w1p(6,3), wmm1(6,3), wmm2(6,3), w1pm(6,3),
     3                    w2pm(6,3), xm1, xmm2, x1p, x2p,q1p(0:4,3),
     4                    qm1(0:4,3),qm2(0:4,3),qwpwm1(0:4,3),qwpwm2(0:4,3),
     5                    qwpwmwm(0:4,3),qwwwm(0:4,3)


c---------------------leptonic tensors for w+w-w+/- --------------------------
      double complex WWW_aww, WWW_zww, wptowww, wmtowww
      common /tenswww/ WWW_aww(0:5,3,3), WWW_zww(0:5,3,3),
     1                wptowww(0:5,3),wmtowww(0:5,3)


c---------------------common block for testing purposes-----------------------
      double complex WWWtamp,WWWtampr
      common /WWWtest/ WWWtamp(6,-1:1,2)
      common /WWWrtest/ WWWtampr(6,-1:1,-1:1,2)

      double complex tamp,tampr
      integer ip,ipr
      common /VVVtest/ tamp(10,-1:1,2), ip
      common /VVVrtest/ tampr(10,-1:1,-1:1,2), ipr
