

c$$$c     D0fin(s,t,qq1sq,qq2sq,musq)
c$$$c                     k
c$$$c     p1 ->-----------<-------------<-- q2
c$$$c             |                 |
c$$$c             |                 |
c$$$c             |                 |  
c$$$c     p2 ->-------------------------<-- q1
c$$$c
c$$$c
c$$$c    s=(p1+p2)^2
c$$$c    t=(p2+q1)^2
c$$$c    p1^2=0, p2^2=0, q1^2=qq1sq<>0, q2=qq2sq^2<>0
c$$$c    musq = mu^2 e' una scala dimensionale esterna!!
c$$$c 
c$$$c  int d^dk/(2 pi)^d 1/(k^2)/(k+p1)^2/(k+p1+p2)^2/(k+p1+p2+q1)^2= 
c$$$c          N_ep * D0fin(s,t,q1^2,q2^2)
c$$$c          N_ep = i/(4 pi)^2 (4 pi)^ep Gamma(1+ep) (musq)^(-ep)
c$$$
c$$$      function D0fin(s,t,qq1sq,qq2sq,musq)
c$$$      implicit none
c$$$      complex * 16 D0fin
c$$$      real * 8 s,t,qq1sq,qq2sq,musq
c$$$c     ris(1) = finite part, ris(2) = coeff of 1/ep, 
c$$$c     ris(3) = coeff of 1/ep^2      
c$$$      complex * 16 ris(3)
c$$$      real * 8 r1,r2,l1,l2,l1mr1,l1mr2,lsomu2,tmp,q1sq,q2sq
c$$$      real * 8 dilog
c$$$      complex * 16 I
c$$$      parameter (I=(0,1))
c$$$      double precision pi
c$$$      parameter (pi=3.141592653589793238462643383279502884197D0)
c$$$      integer j
c$$$c      complex*16  D0t
c$$$
c$$$      if (musq.lt.0) then
c$$$         write(*,*) 'ERROR in D0fin: mu^2 MUST be a positive number'
c$$$         stop
c$$$      endif
c$$$
c$$$c      write(*,*) 'D0 with args',s,t,qq1sq,qq2sq,musq
c$$$
c$$$c      d0fin = D0t(s,t,qq1sq,qq2sq)
c$$$c      return
c$$$
c$$$      q1sq = qq1sq
c$$$      q2sq = qq2sq
c$$$
c$$$
c$$$      if ((q1sq.gt.0d0).and.(q2sq.lt.0d0)) then
c$$$c exchange who is positive with the one that is negative         
c$$$         tmp = q1sq
c$$$         q1sq = q2sq
c$$$         q2sq = tmp
c$$$      endif
c$$$         
c$$$      if ((s.lt.0.d0).and.(t.lt.0.d0).and.
c$$$     #     (q1sq.lt.0).and.(q2sq.gt.0)) then
c$$$         r1 = t/q1sq
c$$$         r2 = t/q2sq
c$$$         l1 = log(r1)
c$$$         l2 = log(-r2)
c$$$         l1mr2 = log(1.d0-r2)
c$$$         lsomu2 = log(-s/musq)         
c$$$         if (r1.lt.1.d0) then
c$$$            ris(3) = 1.d0
c$$$            ris(2) = -(l1+l2) - I*pi
c$$$            ris(1) = -2*(
c$$$     #           dilog(r1) + l1*log(1.d0-r1) + 
c$$$     #           dilog(r2) + l2*l1mr2) + 1.d0/2*(l1**2+l2**2)+l1*l2
c$$$     #           + I*pi*(-2*l1mr2+l2+l1)
c$$$     #           + 1.d0/2*lsomu2**2 - lsomu2*ris(2)
c$$$            ris(2) = ris(2) - lsomu2
c$$$
c$$$         elseif (r1.ge.1.d0) then
c$$$            ris(3) = 1.d0
c$$$            ris(2) = -(l1+l2) - I*pi
c$$$            ris(1) = -2*(
c$$$     #           -dilog(q1sq/t)-1.d0/2*l1**2+pi**2/3+l1*log(r1-1.d0)
c$$$     #           +dilog(r2) + l2*l1mr2) + 1.d0/2*(l1**2+l2**2)+l1*l2
c$$$     #           + I*pi*(-2*l1mr2+l2+l1)
c$$$     #           + 1.d0/2*lsomu2**2 - lsomu2*ris(2)
c$$$            ris(2) = ris(2) - lsomu2
c$$$         endif                    
c$$$      elseif ((s.lt.0.d0).and.(t.gt.0.d0).and.
c$$$     #        (q1sq.lt.0).and.(q2sq.gt.0)) then
c$$$         r1 = t/q1sq
c$$$         r2 = t/q2sq
c$$$         l1 = log(-r1)
c$$$         l2 = log(r2)
c$$$         l1mr1 = log(1.d0-r1)
c$$$         lsomu2 = log(-s/musq)               
c$$$         if (r2.lt.1.d0) then
c$$$            ris(3) = 1.d0
c$$$            ris(2) = -(l1+l2) + I*pi
c$$$            ris(1) = -2*(
c$$$     #           dilog(r1) + l1*l1mr1 + 
c$$$     #           dilog(r2) + l2*log(1-r2))+1.d0/2.d0*(l1**2+l2**2)+l1*l2
c$$$     #           + I*pi*( 2*l1mr1-l1-l2)
c$$$     #           + 1.d0/2*lsomu2**2 - lsomu2*ris(2)
c$$$            ris(2) = ris(2) - lsomu2
c$$$
c$$$         elseif (r2.ge.1.d0) then
c$$$            ris(3) = 1.d0
c$$$            ris(2) = -(l1+l2) + I*pi
c$$$            ris(1) = -2*(
c$$$     #           dilog(r1) + l1*l1mr1 + 
c$$$     #           -dilog(q2sq/t)-1.d0/2*l2**2+pi**2/3+l2*log(r2-1.d0))
c$$$     #           +1.d0/2.d0*(l1**2+l2**2)+l1*l2
c$$$     #           + I*pi*( 2*l1mr1-l2-l1)
c$$$     #           + 1.d0/2*lsomu2**2 - lsomu2*ris(2)
c$$$            ris(2) = ris(2) - lsomu2
c$$$         endif                    
c$$$      else
c$$$         write(*,*) 'ERROR in the D0fin function. Cannot be called with
c$$$     #        these arguments'
c$$$         write(*,*) 's,t,q1^2,q2^2',s,t,q1sq,q2sq
c$$$         write(*,*) 'RETURN ZERO!!!'
c$$$         D0fin = 0d0
c$$$         return
c$$$c         stop
c$$$      endif
c$$$
c$$$      do j=1,3
c$$$         ris(j) = ris(j) /(s*t)
c$$$      enddo
c$$$      
c$$$      D0fin = ris(1)
c$$$      end
c$$$
c$$$
